转360次就一定会转回来,刚开始我还在想应该使用最小公倍数吧,后来想了想才发现用360就可以了,用最小公倍数麻烦的多,甚至可能还慢些! 然后忽然发现比较麻烦的一个地方就是每个轮子有5个孔,不好放在循环里,不知道怎么弄,看了下别人的建议,发现我好傻,直接使用数组记录就可以了,:-),每个空隙在数组中+1,最后等于5的就是。但是现在觉得可能这么也不好,因为如果出现了某一个轮胎上两个孔重叠不就可能出问题了,但是这个只出现在数据上,不合逻辑所以就没有这种数据吧,所以我AC了,但是这还是要考虑下,如果这样的话,还是是用数组,但是不用+1了,而是用二进制,每个轮胎的缝隙不+1而是把这个轮胎所在的那个位置1,不过其实都是多虑了,代码如下:
分类: 技术
-
USACO 3.2.3 Spinning Wheels 解题报告
de lang="c"> / LANG: C ID: yylogoo1 PROG: spin / #include #include int used[360]; struct ro{ int v; int count; struct bug{ int start, width; }bug[5]; }roll[5]; int check(void) { int i, j, k; struct bug t; for(i = 0; i <5 i forj="0;" j rollicount j t="roll[i].bug[j];" fork="0;" k="t.width;" k usedk tstart fori="0;" i i ifusedi>= 5){ return 1; } } memset(used, 0, sizeof(used)); return 0; } int main(void) { int i, j, k; struct bug t; freopen("spin.in", "r", stdin); freopen("spin.out", "w", stdout); for(i = 0; i <5 i scanfdd rolliv rollicount forj="0;" j rollicount j scanfdd rollibugjstart rollibugjwidth fori="0;" i i ifcheck break forj="0;" j j fork="0;" k rolljcount k rolljbugkstart="(roll[j].bug[k].start" rolljv ifi="= 360){" printfnonen return printfdn i return co de> -
USACO 3.2.2 Stringsobits 解题报告
这题最开始,我是爆搜,从1向上递增地搜,没过,超时了;后来用深搜,直接搜位数小于等于l的,也超时了,实在没有办法了,到网上看了题解,天!好简单阿! f[i][j]代表i位长的且1最多为j的二进制数的个数,那么就有一个DP方程,f[i][j] = f[i – 1][j] + f[i – 1][j – 1] 因为第i位要么是1要么是0,如果是0那个数就是f[i – 1][l],如果是1就是f[i – 1][j – 1]。 之后,根据f[i][j]就可以确定输出了,从f[n][l]开始,如果m<=f[n – 1][l],那么就0,否则就输出1,且l–, m -= f[n – 1][l] 代码如下:
de lang="c"> / LANG: C ID: yylogoo1 PROG: kimbits / #include int f[32][32]; int main(void) { int i, j; int n, l; unsigned m; freopen("kimbits.in", "r", stdin); freopen("kimbits.out", "w", stdout); scanf("%d%d%u", &n, &l, &m); for(i = 0; i 0; i–){ if(m -
USACO 3.2.1 Factorials 解题报告
花了出奇的长时间,以前我是做过这题的,但是当时的话并没有实际的考虑清楚,因为我知道10就是由2和5组成的,我当时的算法就是用ans保存当前的尾数,然后遇到一个5就除以二,但是没考虑平方,那我就保存后5尾数就AC了,但是这个做法是欠妥的,你想啊,如果万一那个尾数是100002,虽然不切实际(如果切实际我就不能AC),但是确实不够严谨。 想了好久,想到了一个算法,不会怕特殊情况了,先把所有的5的个数统计出来,然后除去相应的2就可以了。 代码如下:
/ LANG: C ID: yyogoo1 PROG: fact4 / #includeint main(void) { int ans = 1; int i, j; int n, k = 0; freopen("fact4.in", "r", stdin); freopen("fact4.out", "w", stdout); scanf("%d", &n); for(i = 2; i -
USACO 3.1.6 Stamps 解题报告
这一题我就用的动态规划:f[l]=max(f[l], f[l – num[i]]); f[0] = 1; l是总面额,i是第num[i]个邮票的面值,但是超时,没想到别的算法,怎么办?找地方剪枝,见了三处就AC了,这效果立竿见影啊!后来到网上看了下,还有更快的方法,我是三重循环,它是二重循环,用f来记录当前使用的邮票总数(这种方法到别出去吧~- –)
-
USACO 3.1.5 Contact 解题报告
这个题目其实算法还是比较简单,关键是怎么保存这些数字,其实啊,最好的保存方法就是二进制,且增加前缀1,比如0就是二进制10即十进制2,想必聪明的你要问为什么需要前缀1了,为什么呢?如果不要的话那么0和00都是二进制的0,怎么区分呢?所以用前缀1,那么最大的话也就是12位的1加一个前缀1,2^13=8192,接下来自己想想吧。
-
USACO 3.1.4 Shaping Regions 解题报告
这个题目用数组来记录纸的每一个颜色是不可能的,无论是时间上还是空间上都无法忍受,就只能用具体的矩形来表示了,比如底纸,就是一张(0, 0, a, b, 1)的底纸,代表起始坐标是(0, 0)末坐标是(a, b)颜色是1,将它加入数组作为第一个元素,当添加进了一个新的矩形的时候,将数组所有的元素都和这个新的矩形比较,如果该元素被盖住了,就把数组中的那个元素拆分成几个没有被盖住的元素。 其实描述的很笼统,代码明天加入吧,在Ubuntu里面,现在不想切换过去了。 代码如下:
de lang="c">/ ID: yylogoo1 PROG: rect1 LANG: C / #include struct paper{ int x1, y1; int x2, y2; int c; }; struct paper pa[4001]; int len; int stack[4000]; int top; int pop(void) { if(top == 0){ return len++; } return stack[–top]; } void push(int k) { stack[top++] = k; } void add(struct paper t) { int k; k = pop(); pa[k] = t; } void del(int k) { pa[k].x1 = -1; push(k); } void deal(struct paper new, int old_n) { struct paper old = pa[old_n], t; if(new.x1 <= old.x2 || old.x1 <= new.x2){ return ; } if(new.y1 <= old.y2 || old.y1 <= new.y2){ return ; } del(old_n); if(new.x1 = old.x2 && new.y2 <= old.y2){ return ; } if(old.x1 new.x2){ t = old; t.x1 = new.x2; add(t); old.x2 = new.x2; } if(old.y2 < new.y2){ t = old; t.y1 = new.y2; add(t); old.y2 = new.y2; } } int color[2501]; int main(void) { int n; int i, j; int a, b; struct paper t; freopen("rect1.in", "r", stdin); freopen("rect1.out", "w", stdout); scanf("%d%d%d", &a, &b, &n); add((struct paper){0, 0, a, b, 1}); for(i = 0; i = 0){ color[pa[i].c] += (pa[i].x2 – pa[i].x1) * (pa[i].y2 – pa[i].y1); } } for(i = 1; i <2500 i ifcolori> 0){ printf("%d %d\n", i, color[i]); } } return 0; } de> -
USACO 3.1.3 Humble Numbers 解题报告
这个题目属于什么算法呢?我才疏学浅不知道,反正就是用num来记录丑数,假设1为丑数,代码实现会简单些,那么丑数必定就等于另外一个丑数乘以一个素数,那么再一个个的按大小找到前n个丑数,就可以了。 时间的话大概是O(nm),对每个素数都记录该和哪个丑数相乘start[i],如果sub[i](第i个素数)num[start[i]]是下一个丑数,那么start[i]就加一,如果sub[i]num[start[i]]和当前最大的丑数(就是才成为丑数的丑数)相等的话那start[i]也是要加一的,就这样循环。
/LANG: C ID: yylogoo1 PROG: humble / #includeunsigned sub[100], num[100000]; int start[100]; int len; void add(int k) { num[len++] = k; } int main(void) { int i, j, k; int m, n; int min, in; freopen("humble.in", "r", stdin); freopen("humble.out", "w", stdout); scanf("%d%d", &m, &n); for(i = 0; i <m i scanfu subi add whilelen="n){" min="0xFFFFFFFF;" fori="0;" i m i ifsubi numstarti="= num[len" - starti ifmin> sub[i] num[start[i]]){ in = i; min = sub[i] * num[start[i]]; } } add(min); start[in]++; } printf("%u\n", num[n]); return 0; } -
USACO 3.1.2 Score Inflation 解题报告
这题和第三章第一题一样,标准的无限01背包,直接把代码放进去就可以了,代码:
/ LANG: C ID: yylogoo1 PROG: inflate / #includeint f[10001]; #define max(a, b) ((a)<(b)?(a):(b)) int main(void) { int m, n; int i, j; int a, b; freopen("inflate.in", "r", stdin); freopen("inflate.out", "w", stdout); scanf("%d%d", &m, &n); for(i = 0; i <n i scanfdd a b forj="b;" j="m;" j fj="max(f[j" - b a fj printfdn fm return code> -
USACO 3.1.1 Agri-Net 解题报告
这题的话,是最小生成树的标准题,但是最小生成树我不记得写了,后来想起来了之后发现这个二叉堆实现很麻烦,就看看标称的二叉堆是怎么实现的,结果标称直接暴力就是,呵呵,感觉有点投机取巧,因为数据小所以这样。 晚点捉摸下二叉堆的实现,先把这题的代码贴上来(暴力搜的)
/ LANG: C ID: yylogoo1 PROG: agrinet / #includeint map[100][100]; int used[100]; int main(void) { int i, j, k, l; int n; int ans = 0, t; freopen("agrinet.in", "r", stdin); freopen("agrinet.out", "w", stdout); scanf("%d", &n); for(i = 0; i -
USACO 2.4.5 Fractions to Decimals 解题报告
这题的话,其实也好说,就是利用余数进行判断,看代码吧:
de lang="C">/ LANG: C ID: yylogoo1 PROG: fracdec / #include int num[100001]; int mod[100001]; char str[77]; int len; void add(char ch) { if(len == 76){ printf("%s\n", str); str[0] = ‘\0’; len = 0; } str[len++] = ch; } void output(int start, int end) { int i; for(i = start; i